GTPin: GTReplay: Execution API

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

Functions
GTReplay: Execution API

A group of GTReplay APIs that provide access to the state of the emulated thread and the kernel More...

## Functions
GTREPLAY_API void | GTReplay_Run (GTReplayKernel kernel)
GTREPLAY_API void | GTReplay_SetThreadData (GTReplayState state, void *data)
GTREPLAY_API void * | GTReplay_GetThreadData (GTReplayState state)
GTREPLAY_API uint32_t | GTReplay_GetSlmId (GTReplayState state)
GTREPLAY_API uint32_t | GTReplay_GetBarrierId (GTReplayState state)
GTREPLAY_API uint32_t | GTReplay_GetBindingTablePointer (GTReplayState state)
GTREPLAY_API void | GTReplay_GetThreadGroupId (GTReplayState state, uint32_t *x, uint32_t *y, uint32_t *z)
GTREPLAY_API uint32_t | GTReplay_GetGroupSize (GTReplayKernel kernel)
GTREPLAY_API uint32_t | GTReplay_GetModel (GTReplayKernel kernel)
GTREPLAY_API void | GTReplay_GetKernelName (GTReplayKernel kernel, uint32_t *size, char *buf)
GTREPLAY_API uint32_t | GTReplay_MaxNumOfHWThreads (uint32_t model)
GTREPLAY_API uint32_t | GTReplay_MaxNumOfTiles (GTReplayKernel kernel)
GTREPLAY_API uint32_t | GTReplay_RegisterWidth (uint32_t model)
GTREPLAY_API void | GTReplay_ConvertTidToComponents (uint32_t model, uint32_t tid, uint32_t *slice, uint32_t *dualSubSlice, uint32_t *subSlice, uint32_t *euid, uint32_t *id)

## Detailed Description

A group of GTReplay APIs that provide access to the state of the emulated thread and the kernel

## Function Documentation

GTREPLAY_API void GTReplay_ConvertTidToComponents | ( | uint32_t | model,
|  | uint32_t | tid,
|  | uint32_t * | slice,
|  | uint32_t * | dualSubSlice,
|  | uint32_t * | subSlice,
|  | uint32_t * | euid,
|  | uint32_t * | id
| ) |  |

Convert a packed TID value to components - slice, dual-sub-slice, sub-slice, euid, id

Parameters:

  [in] | model | GEN model ID
  [in] | tid | packed TID value to be unpacked
  [out] | slice | slice ID
  [out] | dualSubSlice | dual sub-slice ID (0xFFFFFFFF if not applicable)
  [out] | subSlice | sub-slice ID
  [out] | euid | EU ID
  [out] | id | thread ID within EU

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_GetBarrierId | ( | GTReplayState | state | ) |

Returns:
  barrier index of the current SW thread

Parameters:

  [in] | state | handle to a hardware thread state

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_GetBindingTablePointer | ( | GTReplayState | state | ) |

Returns:
  binding table base pointer of the current SW thread

Parameters:

  [in] | state | handle to a hardware thread state

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_GetGroupSize | ( | GTReplayKernel | kernel | ) |

Returns:
  thread group size of the given kernel

Parameters:

  [in] | kernel | a kernel handle

Availability:
  - execution

GTREPLAY_API void GTReplay_GetKernelName | ( | GTReplayKernel | kernel,
|  | uint32_t * | size,
|  | char * | buf
| ) |  |

Copies an array of chars containing the kernel name to the provided buffer

Parameters:

  [in] | kernel | a kernel handle
  [in,out] | size | pointer to a uint32_t to return the name size in characters
  [in,out] | pointer | to the buffer of the size "size" allocated by the caller. if NULL, only the size is returned.

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_GetModel | ( | GTReplayKernel | kernel | ) |

Returns:
  GEN model of the given kernel (trace) (enum GED_MODEL)

Parameters:

  [in] | kernel | a kernel handle

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_GetSlmId | ( | GTReplayState | state | ) |

Returns:
  Shared Local Memory base index of the current SW thread

Parameters:

  [in] | state | handle to a hardware thread state

Availability:
  - execution

GTREPLAY_API void* GTReplay_GetThreadData | ( | GTReplayState | state | ) |

Returns:
  data associated with a hardware thread state

Parameters:

  [in] | state | handle to a hardware thread state

Availability:
  - execution

GTREPLAY_API void GTReplay_GetThreadGroupId | ( | GTReplayState | state,
|  | uint32_t * | x,
|  | uint32_t * | y,
|  | uint32_t * | z
| ) |  |

Return thread group ID of the current SW thread

Parameters:

  [in] | state | handle to a hardware thread state
  [out] | x | pointer to X component
  [out] | y | pointer to Y component
  [out] | z | pointer to Z component

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_MaxNumOfHWThreads | ( | uint32_t | model | ) |

Returns:
  max number of HW threads supported for given model

Parameters:

  [in] | model | GEN model ID

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_MaxNumOfTiles | ( | GTReplayKernel | kernel | ) |

Returns:
  max number of tiles

Parameters:

  [in] | kernel | a kernel handle

Availability:
  - execution

GTREPLAY_API uint32_t GTReplay_RegisterWidth | ( | uint32_t | model | ) |

Returns:
  register width supported for given model

Parameters:

  [in] | model | GEN model ID

Availability:
  - execution

GTREPLAY_API void GTReplay_Run | ( | GTReplayKernel | kernel | ) |

Replay a given kernel (trace)

Parameters:

  [in] | kernel | a kernel handle

Availability:
  - execution

GTREPLAY_API void GTReplay_SetThreadData | ( | GTReplayState | state,
|  | void * | data
| ) |  |

Associate state of a hardware thread with a given data

Parameters:

  [in] | state | handle to a hardware thread state
  [in] | data | a pointer to associated data

Availability:
  - execution

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT